CREATE TABLE IF NOT EXISTS `#__jforms_forms` (
	`id` int(11) NOT NULL auto_increment,
	`name` VARCHAR(255) NOT NULL ,
	`alias` VARCHAR(255) ,
	`description` TEXT ,
	`fieldsets` LONGTEXT ,
	`fields` LONGTEXT ,
	`message_after_submit` TEXT ,
	`language_file` VARCHAR(255) ,
	`emails` LONGTEXT ,
	`redirect_after_submit` VARCHAR(255) ,
	`events` LONGTEXT ,
	`layouts` LONGTEXT ,
	`integrations` LONGTEXT ,
	`save_data_in_db` TINYINT DEFAULT 1 ,
	`generate_pdf` TINYINT DEFAULT 1 ,
	`layout_type` VARCHAR(255) DEFAULT 'wizard' ,
	`options` LONGTEXT ,
	`published` INT(11) DEFAULT 1 ,
	`access` VARCHAR(255) DEFAULT 1 ,
	`acl` LONGTEXT ,
	`ordering` INT(11) ,

	PRIMARY KEY  (`id`),
	UNIQUE(alias)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jforms_submissions` (
	`id` int(11) NOT NULL auto_increment,
	`created_by` INT(11) ,
	`form_id` INT(11) ,
	`creation_date` INT ,
	`ip_address` VARCHAR(255) ,
	`form_data` LONGTEXT ,
	`jforms_snapshot` LONGTEXT ,
	`pdf` VARCHAR(255) ,
	`passphrase` VARCHAR(255) ,
	`status` VARCHAR(255) DEFAULT 'na' ,
	`payment_status` VARCHAR(255) DEFAULT 'na' ,
	`payment_details` LONGTEXT ,

	PRIMARY KEY  (`id`),
	UNIQUE(passphrase)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(1, 'Field types', 'cmqQCosP52', '<p>An example of all the field types available</p>', '[{"id":1,"enabled":true,"mirror":"","name":"Basic","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0},{"id":2,"enabled":true,"mirror":"","name":"Advanced","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":1},{"id":4,"enabled":true,"mirror":"","name":"Address picker","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":2},{"id":3,"enabled":true,"mirror":"","name":"Special","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":3}]', '[{"id":1,"enabled":true,"fieldset":"1","name":"test","label":"Test","label_engb":"","description":"You can add a description here","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":0},{"id":3,"enabled":true,"fieldset":"1","name":"calendar","label":"Calendar","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcalendar","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","format":"d M Y","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":1},{"id":5,"enabled":true,"fieldset":"1","name":"checkbox","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":2},{"id":6,"enabled":true,"fieldset":"1","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":3},{"id":10,"enabled":true,"fieldset":"1","name":"textarea","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":4},{"id":11,"enabled":true,"fieldset":"1","name":"file","label":"File","label_engb":"","description":"","description_engb":"","type":"ckfile","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"maxSize":"2","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"download":true,"preview":true,"width":"","height":"","thumbnails":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":5},{"id":33,"enabled":true,"fieldset":"1","name":"filelist","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","latitude":38.1156879,"longitude":13.3612671,"hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":6},{"id":13,"enabled":true,"fieldset":"1","name":"hidden","label":"this is an hidden field","label_engb":"","description":"","description_engb":"","type":"ckhidden","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":7},{"id":14,"enabled":true,"fieldset":"1","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":8},{"id":15,"enabled":true,"fieldset":"1","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":9},{"id":22,"enabled":true,"fieldset":"1","name":"radio","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":10},{"id":18,"enabled":true,"fieldset":"2","name":"media","label":"Media","label_engb":"","label_itit":"","description":"You can have description here","description_engb":"","description_itit":"","type":"ckmedia","afterinput":"","afterinput_engb":"","afterinput_itit":"","class":"","containerClass":"","default":"","directory":"demo","target":"_self","preview":true,"width":"","height":"","placeholder":"This is a placeholder","placeholder_engb":"","placeholder_itit":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"","condRules":"","priceRules":"","ordering":11},{"id":19,"enabled":true,"fieldset":"2","name":"meter","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":12},{"id":20,"enabled":true,"fieldset":"2","name":"number","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":13},{"id":8,"enabled":true,"fieldset":"2","name":"languages","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":14},{"id":7,"enabled":true,"fieldset":"2","name":"color","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"","priceRules":"[]","ordering":15},{"id":16,"enabled":true,"fieldset":"2","name":"editor","label":"Editor","label_engb":"","description":"","description_engb":"","type":"ckeditor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":16},{"id":23,"enabled":true,"fieldset":"2","name":"range","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":17},{"id":25,"enabled":true,"fieldset":"2","name":"spacer","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">This is a spacer and could contains plain text or HTML<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n    <th>Entry Header 3<\\/th>\\r\\n    <th>Entry Header 4<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n    <td>Entry First Line 3<\\/td>\\r\\n    <td>Entry First Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n    <td>Entry Line 3<\\/td>\\r\\n    <td>Entry Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Last Line 1<\\/td>\\r\\n    <td>Entry Last Line 2<\\/td>\\r\\n    <td>Entry Last Line 3<\\/td>\\r\\n    <td>Entry Last Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":18},{"id":47,"enabled":true,"fieldset":"2","name":"state","label":"State","label_engb":"","description":"description","description_engb":"","type":"ckstate","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","display":"radio","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":19},{"id":48,"enabled":true,"fieldset":"2","name":"sql","label":"Sql","label_engb":"","description":"This SQL field example get the article list from the DB","description_engb":"","type":"cksql","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"query":"SELECT id, title FROM #__content","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","key_field":"id","value_field":"title","translate":false,"validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":20},{"id":2,"enabled":true,"fieldset":"4","name":"address-picker","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"input-xxlarge","containerClass":"","default":"","distanceWidget":true,"distanceWidgetRadius":20000,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","cssSelectorTarget":".myaddress","mapType":"TERRAIN","zoom":"9","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"focue me :-)","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":21},{"id":67,"enabled":true,"fieldset":"4","name":"latitude","label":"Latitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress latitude","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":22},{"id":68,"enabled":true,"fieldset":"4","name":"longitude","label":"Longitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress longitude","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":23},{"id":55,"enabled":true,"fieldset":"4","name":"street_number","label":"Street number","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress street_number","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":24},{"id":56,"enabled":true,"fieldset":"4","name":"street","label":"Street","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress street","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":25},{"id":57,"enabled":true,"fieldset":"4","name":"zip","label":"Zip","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress zip","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":26},{"id":58,"enabled":true,"fieldset":"4","name":"city","label":"City","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress city","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":27},{"id":59,"enabled":true,"fieldset":"4","name":"city_district","label":"City district","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress city_district","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":28},{"id":60,"enabled":true,"fieldset":"4","name":"county","label":"County","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress county","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":29},{"id":61,"enabled":true,"fieldset":"4","name":"county_code","label":"County code","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress county_code","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":30},{"id":62,"enabled":true,"fieldset":"4","name":"region","label":"Region","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress region","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":31},{"id":63,"enabled":true,"fieldset":"4","name":"region_code","label":"Region code","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress region_code","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":32},{"id":64,"enabled":true,"fieldset":"4","name":"country","label":"Country","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress country","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":33},{"id":65,"enabled":true,"fieldset":"4","name":"country_code","label":"Country code","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress country_code","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":34},{"id":66,"enabled":true,"fieldset":"4","name":"distance","label":"Distance","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress distance","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":35},{"id":69,"enabled":true,"fieldset":"4","name":"viewport_ne_lat","label":"Viewport NE latitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress ne_lat","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":36},{"id":70,"enabled":true,"fieldset":"4","name":"viewport_ne_lng","label":"Viewport NE longitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress ne_lng","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":37},{"id":71,"enabled":true,"fieldset":"4","name":"viewport_sw_lat","label":"Viewport SW latitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress sw_lat","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":38},{"id":72,"enabled":true,"fieldset":"4","name":"viewport_sw_lng","label":"Viewport SW longitude","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"myaddress sw_lng","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":true,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":39},{"id":49,"enabled":true,"fieldset":"3","name":"tags","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":40},{"id":9,"enabled":true,"fieldset":"3","name":"datetimepicker","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bold;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":41},{"id":50,"enabled":true,"fieldset":"3","name":"timepicker","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":42},{"id":51,"enabled":true,"fieldset":"3","name":"usergroups","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":43},{"id":26,"enabled":true,"fieldset":"3","name":"repeatable_1","label":"repeatable (example 1)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["27","28","30","31","34","35","12","36","44","39","43","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":44},{"id":45,"enabled":true,"fieldset":"","name":"address-picker_r","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","distanceWidget":false,"distanceWidgetRadius":500,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","cssSelectorTarget":"","mapType":"TERRAIN","zoom":"12","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":45},{"id":27,"enabled":true,"fieldset":"","name":"text_r","label":"Text","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":46},{"id":28,"enabled":true,"fieldset":"","name":"textarea_r","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":47},{"id":30,"enabled":true,"fieldset":"","name":"checkbox_r","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":48},{"id":31,"enabled":true,"fieldset":"","name":"checkboxes_r","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","latitude":0,"longitude":0,"layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":49},{"id":34,"enabled":true,"fieldset":"","name":"listsingle_r","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":50},{"id":35,"enabled":true,"fieldset":"","name":"listmultiple_r","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":51},{"id":12,"enabled":true,"fieldset":"","name":"filelist_r","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":52},{"id":36,"enabled":true,"fieldset":"","name":"radio_r","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":53},{"id":38,"enabled":true,"fieldset":"","name":"meter_r","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","latitude":0,"longitude":0,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":54},{"id":44,"enabled":true,"fieldset":"","name":"spacer_r","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">A spacer inside a repeatable field!<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":55},{"id":46,"enabled":true,"fieldset":"3","name":"repeatable_2","label":"repeatable (example 2)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["53","45","52","32","54","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":56},{"id":53,"enabled":true,"fieldset":"","name":"timepicker_r","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","latitude":0,"longitude":0,"format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":57},{"id":52,"enabled":true,"fieldset":"","name":"tags_r","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","latitude":0,"longitude":0,"min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":58},{"id":32,"enabled":true,"fieldset":"","name":"datetimepicker_r","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","latitude":0,"longitude":0,"mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"selectableTimes\\":[{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":59},{"id":54,"enabled":true,"fieldset":"","name":"usergroups_r","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":60},{"id":39,"enabled":true,"fieldset":"","name":"number_r","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":61},{"id":43,"enabled":true,"fieldset":"","name":"range_r","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":62},{"id":41,"enabled":true,"fieldset":"","name":"color_r","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"","priceRules":"[]","ordering":63},{"id":40,"enabled":true,"fieldset":"","name":"languages_r","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":64},{"id":4,"enabled":true,"fieldset":"3","name":"captcha","label":"Captcha","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":65}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'wizard', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"show_wizard_nav":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions_inherit":true},"7":{"max_submissions_inherit":true},"2":{"max_submissions_inherit":true},"3":{"max_submissions_inherit":true},"4":{"max_submissions_inherit":true},"5":{"max_submissions_inherit":true},"10":{"max_submissions_inherit":true},"11":{"max_submissions":"0"},"12":{"max_submissions_inherit":true},"8":{"max_submissions_inherit":true}}', 1);
INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(2, 'Dynamic fields', 'tFtFM0K9lf', '<p>A simple example of the dynamic fields feature to show / hide a fieldset</p>', '[{"id":4,"enabled":true,"mirror":"","name":"Trigger","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0},{"id":1,"enabled":true,"mirror":"","name":"Basic","name_engb":"","description":"","description_engb":"","class":"form-horizontal condRule[show,#jform_maintrigger,basic]","form_file":"","ordering":1},{"id":2,"enabled":true,"mirror":"","name":"Advanced","name_engb":"","description":"","description_engb":"","class":"form-horizontal condRule[show,#jform_maintrigger,advanced]","form_file":"","ordering":2},{"id":3,"enabled":true,"mirror":"","name":"Special","name_engb":"","description":"","description_engb":"","class":"form-horizontal condRule[show,#jform_maintrigger,special]","form_file":"","ordering":3}]', '[{"id":55,"enabled":true,"fieldset":"4","name":"maintrigger","label":"Main trigger","label_engb":"","description":"","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","layout":"horizontal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Basic\\",\\"label_engb\\":\\"\\",\\"value\\":\\"basic\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Advanced\\",\\"label_engb\\":\\"\\",\\"value\\":\\"advanced\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Special\\",\\"label_engb\\":\\"\\",\\"value\\":\\"special\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":0},{"id":1,"enabled":true,"fieldset":"1","name":"test","label":"Test","label_engb":"","description":"You can add a description here","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":1},{"id":3,"enabled":true,"fieldset":"1","name":"calendar","label":"Calendar","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcalendar","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","format":"d M Y","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":2},{"id":5,"enabled":true,"fieldset":"1","name":"checkbox","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":3},{"id":6,"enabled":true,"fieldset":"1","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":4},{"id":9,"enabled":true,"fieldset":"1","name":"datetimepicker","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":5},{"id":10,"enabled":true,"fieldset":"1","name":"textarea","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":6},{"id":11,"enabled":true,"fieldset":"1","name":"file","label":"File","label_engb":"","description":"","description_engb":"","type":"ckfile","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"maxSize":"2","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"download":true,"preview":true,"width":"","height":"","thumbnails":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":7},{"id":33,"enabled":true,"fieldset":"1","name":"filelist","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","latitude":38.1156879,"longitude":13.3612671,"hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":8},{"id":13,"enabled":true,"fieldset":"1","name":"hidden","label":"this is an hidden field","label_engb":"","description":"","description_engb":"","type":"ckhidden","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":9},{"id":14,"enabled":true,"fieldset":"1","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":10},{"id":15,"enabled":true,"fieldset":"1","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":11},{"id":22,"enabled":true,"fieldset":"1","name":"radio","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":12},{"id":18,"enabled":true,"fieldset":"2","name":"media","label":"Media","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmedia","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","download":true,"preview":true,"width":"","height":"","placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":13},{"id":19,"enabled":true,"fieldset":"2","name":"meter","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":14},{"id":20,"enabled":true,"fieldset":"2","name":"number","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":15},{"id":8,"enabled":true,"fieldset":"2","name":"languages","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":16},{"id":7,"enabled":true,"fieldset":"2","name":"color","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"","priceRules":"[]","ordering":17},{"id":16,"enabled":true,"fieldset":"2","name":"editor","label":"Editor","label_engb":"","description":"","description_engb":"","type":"ckeditor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":18},{"id":23,"enabled":true,"fieldset":"2","name":"range","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":19},{"id":25,"enabled":true,"fieldset":"2","name":"spacer","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">This is a spacer and could contains plain text or HTML<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n    <th>Entry Header 3<\\/th>\\r\\n    <th>Entry Header 4<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n    <td>Entry First Line 3<\\/td>\\r\\n    <td>Entry First Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n    <td>Entry Line 3<\\/td>\\r\\n    <td>Entry Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Last Line 1<\\/td>\\r\\n    <td>Entry Last Line 2<\\/td>\\r\\n    <td>Entry Last Line 3<\\/td>\\r\\n    <td>Entry Last Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":20},{"id":47,"enabled":true,"fieldset":"2","name":"state","label":"State","label_engb":"","description":"description","description_engb":"","type":"ckstate","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","display":"radio","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":21},{"id":48,"enabled":true,"fieldset":"2","name":"sql","label":"Sql","label_engb":"","description":"This SQL field example get the article list from the DB","description_engb":"","type":"cksql","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"query":"SELECT id, title FROM #__content","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","key_field":"id","value_field":"title","translate":false,"validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":22},{"id":2,"enabled":true,"fieldset":"3","name":"address-picker","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","distanceWidget":false,"distanceWidgetRadius":0,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","latitude":38.0774583,"longitude":13.442918,"cssSelectorTarget":"","mapType":"TERRAIN","zoom":"12","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":23},{"id":49,"enabled":true,"fieldset":"3","name":"tags","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":24},{"id":50,"enabled":true,"fieldset":"3","name":"timepicker","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":25},{"id":51,"enabled":true,"fieldset":"3","name":"usergroups","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":26},{"id":26,"enabled":true,"fieldset":"3","name":"repeatable_1","label":"repeatable (example 1)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["27","28","30","31","34","35","12","36","44","39","43","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":27},{"id":27,"enabled":true,"fieldset":"","name":"text_r","label":"Text","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":28},{"id":28,"enabled":true,"fieldset":"","name":"textarea_r","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":29},{"id":30,"enabled":true,"fieldset":"","name":"checkbox_r","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":30},{"id":31,"enabled":true,"fieldset":"","name":"checkboxes_r","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","latitude":0,"longitude":0,"layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":31},{"id":34,"enabled":true,"fieldset":"","name":"listsingle_r","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":32},{"id":35,"enabled":true,"fieldset":"","name":"listmultiple_r","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":33},{"id":12,"enabled":true,"fieldset":"","name":"filelist_r","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":34},{"id":36,"enabled":true,"fieldset":"","name":"radio_r","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":35},{"id":38,"enabled":true,"fieldset":"","name":"meter_r","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","latitude":0,"longitude":0,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":36},{"id":44,"enabled":true,"fieldset":"","name":"spacer_r","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">A spacer inside a repeatable field!<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":37},{"id":46,"enabled":true,"fieldset":"3","name":"repeatable_2","label":"repeatable (example 2)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["53","45","52","32","54","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":38},{"id":53,"enabled":true,"fieldset":"","name":"timepicker_r","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","latitude":0,"longitude":0,"format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":39},{"id":45,"enabled":true,"fieldset":"","name":"address-picker_r","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","distanceWidget":false,"distanceWidgetRadius":0,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","cssSelectorTarget":"","mapType":"TERRAIN","zoom":"12","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":40},{"id":52,"enabled":true,"fieldset":"","name":"tags_r","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","latitude":0,"longitude":0,"min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":41},{"id":32,"enabled":true,"fieldset":"","name":"datetimepicker_r","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","latitude":0,"longitude":0,"mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"selectableTimes\\":[{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":42},{"id":54,"enabled":true,"fieldset":"","name":"usergroups_r","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":43},{"id":39,"enabled":true,"fieldset":"","name":"number_r","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":44},{"id":43,"enabled":true,"fieldset":"","name":"range_r","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":45},{"id":41,"enabled":true,"fieldset":"","name":"color_r","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"","priceRules":"[]","ordering":46},{"id":40,"enabled":true,"fieldset":"","name":"languages_r","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":47},{"id":4,"enabled":true,"fieldset":"3","name":"captcha","label":"Captcha","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":48}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions_inherit":true},"7":{"max_submissions_inherit":true},"2":{"max_submissions_inherit":true},"3":{"max_submissions_inherit":true},"4":{"max_submissions_inherit":true},"5":{"max_submissions_inherit":true},"10":{"max_submissions_inherit":true},"11":{"max_submissions":"0"},"12":{"max_submissions_inherit":true},"8":{"max_submissions_inherit":true}}', 2);
INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(3, 'Dynamic fields 2', 'vSgvEXUtbf', '<p>The magic of the dynamic fields, you can show/hide/slideup/slidedown/select/deselect anything you want based on the value of a trigger field</p>', '[{"id":4,"enabled":true,"mirror":"","name":"Dynamic fields","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0}]', '[{"id":55,"enabled":true,"fieldset":"4","name":"maintrigger","label":"Main trigger","label_engb":"","description":"This filled will trigger the various dynamic tasks based on the user selection","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"A\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"B\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"C\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"D\\",\\"label_engb\\":\\"\\",\\"value\\":\\"d\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"},{\\"label\\":\\"E\\",\\"label_engb\\":\\"\\",\\"value\\":\\"e\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"},{\\"label\\":\\"F\\",\\"label_engb\\":\\"\\",\\"value\\":\\"f\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"},{\\"label\\":\\"G\\",\\"label_engb\\":\\"\\",\\"value\\":\\"g\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"},{\\"label\\":\\"H\\",\\"label_engb\\":\\"\\",\\"value\\":\\"h\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"},{\\"label\\":\\"I\\",\\"label_engb\\":\\"\\",\\"value\\":\\"i\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":0},{"id":1,"enabled":true,"fieldset":"4","name":"test","label":"Test","label_engb":"","description":"You can add a description here","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"a\\"}]","priceRules":"[]","ordering":1},{"id":3,"enabled":true,"fieldset":"4","name":"calendar","label":"Calendar","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcalendar","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","format":"d M Y","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"c\\"}]","priceRules":"[]","ordering":2},{"id":5,"enabled":true,"fieldset":"4","name":"checkbox","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"c\\"}]","priceRules":"[]","ordering":3},{"id":6,"enabled":true,"fieldset":"4","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"d\\"}]","priceRules":"[]","ordering":4},{"id":9,"enabled":true,"fieldset":"4","name":"datetimepicker","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"e\\"}]","priceRules":"[]","ordering":5},{"id":10,"enabled":true,"fieldset":"4","name":"textarea","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"f\\"}]","priceRules":"","ordering":6},{"id":11,"enabled":true,"fieldset":"4","name":"file","label":"File","label_engb":"","description":"","description_engb":"","type":"ckfile","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","maxSize":"2","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"download":true,"preview":true,"width":"","height":"","thumbnails":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"g\\"}]","priceRules":"","ordering":7},{"id":33,"enabled":true,"fieldset":"4","name":"filelist","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"g\\"}]","priceRules":"","ordering":8},{"id":14,"enabled":true,"fieldset":"4","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"h\\"}]","priceRules":"","ordering":9},{"id":15,"enabled":true,"fieldset":"4","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"i\\"}]","priceRules":"","ordering":10},{"id":22,"enabled":true,"fieldset":"4","name":"radio","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"a\\"}]","priceRules":"","ordering":11},{"id":18,"enabled":true,"fieldset":"4","name":"media","label":"Media","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmedia","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","download":true,"preview":true,"width":"","height":"","placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"a\\"}]","priceRules":"","ordering":12},{"id":19,"enabled":true,"fieldset":"4","name":"meter","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","latitude":0,"longitude":0,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"b\\"}]","priceRules":"","ordering":13},{"id":20,"enabled":true,"fieldset":"4","name":"number","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"c\\"}]","priceRules":"","ordering":14},{"id":8,"enabled":true,"fieldset":"4","name":"languages","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"d\\"}]","priceRules":"[]","ordering":15},{"id":7,"enabled":true,"fieldset":"4","name":"color","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"e\\"}]","priceRules":"[]","ordering":16},{"id":16,"enabled":true,"fieldset":"4","name":"editor","label":"Editor","label_engb":"","description":"","description_engb":"","type":"ckeditor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"f\\"}]","priceRules":"","ordering":17},{"id":23,"enabled":true,"fieldset":"4","name":"range","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"f\\"}]","priceRules":"","ordering":18},{"id":25,"enabled":true,"fieldset":"4","name":"spacer","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">This is a spacer and could contains plain text or HTML<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n    <th>Entry Header 3<\\/th>\\r\\n    <th>Entry Header 4<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n    <td>Entry First Line 3<\\/td>\\r\\n    <td>Entry First Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n    <td>Entry Line 3<\\/td>\\r\\n    <td>Entry Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Last Line 1<\\/td>\\r\\n    <td>Entry Last Line 2<\\/td>\\r\\n    <td>Entry Last Line 3<\\/td>\\r\\n    <td>Entry Last Line 4<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"g\\"}]","priceRules":"","ordering":19},{"id":47,"enabled":true,"fieldset":"4","name":"state","label":"State","label_engb":"","description":"description","description_engb":"","type":"ckstate","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","display":"radio","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"h\\"}]","priceRules":"","ordering":20},{"id":48,"enabled":true,"fieldset":"4","name":"sql","label":"Sql","label_engb":"","description":"This SQL field example get the article list from the DB","description_engb":"","type":"cksql","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"query":"SELECT id, title FROM #__content","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","key_field":"id","value_field":"title","translate":false,"validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"a\\"}]","priceRules":"","ordering":21},{"id":2,"enabled":true,"fieldset":"4","name":"address-picker","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","distanceWidget":false,"distanceWidgetRadius":0,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","cssSelectorTarget":"","mapType":"TERRAIN","zoom":"12","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"i\\"}]","priceRules":"[]","ordering":22},{"id":49,"enabled":true,"fieldset":"4","name":"tags","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"b\\"}]","priceRules":"","ordering":23},{"id":50,"enabled":true,"fieldset":"4","name":"timepicker","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"c\\"}]","priceRules":"","ordering":24},{"id":51,"enabled":true,"fieldset":"4","name":"usergroups","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"d\\"}]","priceRules":"","ordering":25},{"id":26,"enabled":true,"fieldset":"4","name":"repeatable_1","label":"repeatable (example 1)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["27","28","30","31","34","35","12","36","44","39","43","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"e\\"}]","priceRules":"","ordering":26},{"id":27,"enabled":true,"fieldset":"","name":"text_r","label":"Text","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":27},{"id":28,"enabled":true,"fieldset":"","name":"textarea_r","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","width":"","height":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":28},{"id":30,"enabled":true,"fieldset":"","name":"checkbox_r","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":29},{"id":31,"enabled":true,"fieldset":"","name":"checkboxes_r","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","latitude":0,"longitude":0,"layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":30},{"id":34,"enabled":true,"fieldset":"","name":"listsingle_r","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":38.1156879,"longitude":13.3612671,"multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":31},{"id":35,"enabled":true,"fieldset":"","name":"listmultiple_r","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":32},{"id":12,"enabled":true,"fieldset":"","name":"filelist_r","label":"File list","label_engb":"","description":"","description_engb":"","type":"ckfilelist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","directory":"images","fileFilter":"","exclude":"","hide_none":true,"hide_default":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","stripext":true,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":33},{"id":36,"enabled":true,"fieldset":"","name":"radio_r","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":34},{"id":38,"enabled":true,"fieldset":"","name":"meter_r","label":"Meter","label_engb":"","description":"You can have description here","description_engb":"","type":"ckmeter","active":true,"afterinput":"","afterinput_engb":"","animated":true,"class":"","containerClass":"","color":"#ffaa00","default":"","latitude":0,"longitude":0,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"70","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":35},{"id":44,"enabled":true,"fieldset":"","name":"spacer_r","label":"","label_engb":"","description":"","description_engb":"","type":"ckspacer","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"spacer_content":"<div style=\\"font-size 10px; border-radius: 10px; padding: 10px; border: 1px solid red;\\">\\r\\n<p style=\\"font-size: 16px; font-weight: bold;\\">A spacer inside a repeatable field!<\\/p>\\r\\n<ul>\\r\\n  <li>Lorem ipsum dolor sit amet consectetuer.<\\/li>\\r\\n  <li>Aenean commodo ligula eget dolor.<\\/li>\\r\\n  <li>Aenean massa cum sociis natoque penatibus.<\\/li>\\r\\n<\\/ul>\\r\\n\\r\\n<table style=\\"font-size 10px;\\" class=\\"table table-striped table-bordered table-condensed\\">\\r\\n  <tbody><tr>\\r\\n    <th>Entry Header 1<\\/th>\\r\\n    <th>Entry Header 2<\\/th>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry First Line 1<\\/td>\\r\\n    <td>Entry First Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n  <tr>\\r\\n    <td>Entry Line 1<\\/td>\\r\\n    <td>Entry Line 2<\\/td>\\r\\n  <\\/tr>\\r\\n<\\/tbody><\\/table>\\r\\n<p>Lorem ipsum dolor sit amet, sem.<\\/p>\\r\\n<\\/div>","spacer_content_engb":"","selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":36},{"id":46,"enabled":true,"fieldset":"4","name":"repeatable_2","label":"repeatable (example 2)","label_engb":"","description":"","description_engb":"","type":"ckrepeatable","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"limit":5,"repeatable_fields":["53","45","52","32","54","40"],"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"show\\",\\"task_values\\":\\"\\",\\"trigger\\":\\"55\\",\\"values\\":\\"g\\"}]","priceRules":"","ordering":37},{"id":53,"enabled":true,"fieldset":"","name":"timepicker_r","label":"Timepicker","label_engb":"","description":"Another lightweight but powerfull ByGiro jQuery plugin!","description_engb":"","type":"cktimepicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","start":"0","end":"0","latitude":0,"longitude":0,"format":"H:i","uiFormat":"","minuteStep":5,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","time":"0","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":38},{"id":45,"enabled":true,"fieldset":"","name":"address-picker_r","label":"Address picker","label_engb":"","description":"","description_engb":"","type":"ckaddresspicker","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","distanceWidget":false,"distanceWidgetRadius":0,"addresspicker_center":"Via Municipio, 7, 90039 Villabate PA, Italia","cssSelectorTarget":"","mapType":"TERRAIN","zoom":"12","markerType":"default","mode_ckaddresspicker":"modal","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"[{\\"attribute\\":\\"autocomplete\\",\\"value\\":\\"off\\"}]","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":39},{"id":52,"enabled":true,"fieldset":"","name":"tags_r","label":"Tags","label_engb":"","description":"Another ByGiro jQuery plugin!","description_engb":"","type":"cktags","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"Ciao,Hello,Hola,Maasseleema","latitude":0,"longitude":0,"min":2,"max":6,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator_cktags":",","capitalizeFirstLetter":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":40},{"id":32,"enabled":true,"fieldset":"","name":"datetimepicker_r","label":"Datetime picker","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","latitude":0,"longitude":0,"mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[{\\"selectable\\":\\"1\\",\\"date\\":\\"2014-11-11\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"0\\",\\"repeatWeek\\":\\"1\\",\\"selectableTimes\\":[{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Ciao bello!\\",\\"message_engb\\":\\"\\"},{\\"selectable\\":\\"0\\",\\"date\\":\\"2014-11-13\\",\\"repeatYear\\":\\"0\\",\\"repeatMonth\\":\\"1\\",\\"repeatWeek\\":\\"0\\",\\"selectableTimes\\":[{\\"start\\":\\"18:10\\",\\"end\\":\\"20:05\\"},{\\"start\\":\\"08:00\\",\\"end\\":\\"13:25\\"},{\\"start\\":\\"03:00\\",\\"end\\":\\"05:30\\"}],\\"selectors\\":[{\\"attribute\\":\\"style\\",\\"value\\":\\"font-weight: bolld;\\"}],\\"message\\":\\"Shop closed!\\",\\"message_engb\\":\\"\\"}]","minuteStep":10,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":41},{"id":54,"enabled":true,"fieldset":"","name":"usergroups_r","label":"UserGroups","label_engb":"","description":"","description_engb":"","type":"ckusergrouplist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":42},{"id":39,"enabled":true,"fieldset":"","name":"number_r","label":"number","label_engb":"","description":"You can have description here","description_engb":"","type":"cknumber","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":50,"placeholder":"This is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":3,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":43},{"id":43,"enabled":true,"fieldset":"","name":"range_r","label":"Range","label_engb":"","description":"you can add description to all fields","description_engb":"","type":"ckrange","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"min":0,"max":100,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"step":5,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":44},{"id":41,"enabled":true,"fieldset":"","name":"color_r","label":"Color","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcolor","afterinput":"","afterinput_engb":"","class":"","containerClass":"","layout_ckcolor":"full","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"colorcode","condRules":"","priceRules":"[]","ordering":45},{"id":40,"enabled":true,"fieldset":"","name":"languages_r","label":"Languages","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcontentlanguage","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"multiple":true,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"[]","ordering":46},{"id":4,"enabled":true,"fieldset":"4","name":"captcha","label":"Captcha","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"[]","priceRules":"[]","ordering":47}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions_inherit":true},"7":{"max_submissions_inherit":true},"2":{"max_submissions_inherit":true},"3":{"max_submissions_inherit":true},"4":{"max_submissions_inherit":true},"5":{"max_submissions_inherit":true},"10":{"max_submissions_inherit":true},"11":{"max_submissions":"0"},"12":{"max_submissions_inherit":true},"8":{"max_submissions_inherit":true}}', 3);
INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(4, 'Dynamic fields 3', 'vxiK9kEzIf', '<p>This form will show how to select or deselect values dynamically from another input field</p>', '[{"id":4,"enabled":true,"mirror":"","name":"Dynamic fields","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0}]', '[{"id":55,"enabled":true,"fieldset":"4","name":"maintrigger","label":"Main trigger","label_engb":"","description":"This filled will trigger the various dynamic tasks based on the user selection","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"checkboxes\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"List (single)\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"List (multiple)\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Text\\",\\"label_engb\\":\\"\\",\\"value\\":\\"e\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":0},{"id":6,"enabled":true,"fieldset":"4","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"select\\",\\"task_values\\":\\"a|b\\",\\"trigger\\":\\"55\\",\\"values\\":\\"a\\"}]","priceRules":"[]","ordering":1},{"id":14,"enabled":true,"fieldset":"4","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"select\\",\\"task_values\\":\\"opt3\\",\\"trigger\\":\\"55\\",\\"values\\":\\"b\\"}]","priceRules":"","ordering":2},{"id":15,"enabled":true,"fieldset":"4","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"select\\",\\"task_values\\":\\"opt1|opt3\\",\\"trigger\\":\\"55\\",\\"values\\":\\"c\\"}]","priceRules":"","ordering":3},{"id":56,"enabled":true,"fieldset":"4","name":"test","label":"Text","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"[{\\"task\\":\\"select\\",\\"task_values\\":\\"ciao\\",\\"trigger\\":\\"55\\",\\"values\\":\\"e\\"}]","priceRules":"","ordering":4},{"id":4,"enabled":true,"fieldset":"4","name":"captcha","label":"Captcha","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"[]","priceRules":"[]","ordering":5}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions":"0"},"7":{"max_submissions":"0"},"2":{"max_submissions":"0"},"3":{"max_submissions":"0"},"4":{"max_submissions":"0"},"5":{"max_submissions":"0"},"10":{"max_submissions":"0"},"11":{"max_submissions":"0"},"12":{"max_submissions":"0"},"8":{"max_submissions":"0"}}', 4),
(5, 'JS validations', 'lH5xuQgd7S', 'an example of the JS validations', '[{"id":1,"enabled":true,"ordering":0,"mirror":"","name":"JS validations","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":""}]', '[{"id":3,"enabled":true,"fieldset":"1","name":"text","label":"Required","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Just a required field","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":0},{"id":1,"enabled":true,"fieldset":"1","name":"color","label":"Color","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"#ffffff","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"colorcode","filter":"STRING","condRules":"","priceRules":"","ordering":1},{"id":2,"enabled":true,"fieldset":"1","name":"credit_card","label":"Credit card","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"xxxx xxxx xxxx xxxx","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"creditcard","filter":"STRING","condRules":"","priceRules":"","ordering":2},{"id":7,"enabled":true,"fieldset":"1","name":"decimal2","label":"Decimal2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"XXXXXXXXX.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal2","filter":"STRING","condRules":"","priceRules":"","ordering":3},{"id":6,"enabled":true,"fieldset":"1","name":"decimal3to1","label":"decimal3to1","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"12.1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal3to1","filter":"STRING","condRules":"","priceRules":"","ordering":4},{"id":5,"enabled":true,"fieldset":"1","name":"decimal5to2","label":"Decimal5to2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"123.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal5to2","filter":"STRING","condRules":"","priceRules":"","ordering":5},{"id":4,"enabled":true,"fieldset":"1","name":"decimal7to2","label":"Decimal7to2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"12345.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal7to2","filter":"STRING","condRules":"","priceRules":"","ordering":6},{"id":8,"enabled":true,"fieldset":"1","name":"decimal11to8","label":"Decimal11to8","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"123.12345678","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal11to8","filter":"STRING","condRules":"","priceRules":"","ordering":7},{"id":9,"enabled":true,"fieldset":"1","name":"decimal15to5","label":"Decimal15to5","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"1234567890.12345","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimal15to5","filter":"STRING","condRules":"","priceRules":"","ordering":8},{"id":10,"enabled":true,"fieldset":"1","name":"decimalcomma","label":"Decimalcomma","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"x,x","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"decimalcomma","filter":"STRING","condRules":"","priceRules":"","ordering":9},{"id":11,"enabled":true,"fieldset":"1","name":"digit","label":"Digit","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"digit","filter":"STRING","condRules":"","priceRules":"","ordering":10},{"id":12,"enabled":true,"fieldset":"1","name":"domain","label":"Domain","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"http:\\/\\/www.bygiro.com","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"domain","filter":"STRING","condRules":"","priceRules":"","ordering":11},{"id":13,"enabled":true,"fieldset":"1","name":"doublequote","label":"Doublequote","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Anything except \\" (double quote)","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"doublequote","filter":"STRING","condRules":"","priceRules":"","ordering":12},{"id":14,"enabled":true,"fieldset":"1","name":"email","label":"Email","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"peter@griffin.com","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"email","filter":"STRING","condRules":"","priceRules":"","ordering":13},{"id":15,"enabled":true,"fieldset":"1","name":"file","label":"File","label_engb":"","description":"","description_engb":"","type":"ckfile","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","maxSize":"0.5","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"target":"_self","preview":true,"width":"","height":"","thumbnails":"","placeholder":"select a file MAX 500k","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"file","filter":"STRING","condRules":"","priceRules":"","ordering":14},{"id":16,"enabled":true,"fieldset":"1","name":"ip","label":"IP address","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"127.0.0.1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"ip","filter":"STRING","condRules":"","priceRules":"","ordering":15},{"id":17,"enabled":true,"fieldset":"1","name":"length-2","label":"length 2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"2 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length2","filter":"STRING","condRules":"","priceRules":"","ordering":16},{"id":18,"enabled":true,"fieldset":"1","name":"length-4","label":"length 4","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"4 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length4","filter":"STRING","condRules":"","priceRules":"","ordering":17},{"id":19,"enabled":true,"fieldset":"1","name":"length-8","label":"length 8","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"8 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length8","filter":"STRING","condRules":"","priceRules":"","ordering":18},{"id":20,"enabled":true,"fieldset":"1","name":"length-16","label":"length 16","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"16 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length16","filter":"STRING","condRules":"","priceRules":"","ordering":19},{"id":21,"enabled":true,"fieldset":"1","name":"length-32","label":"length 32","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"32 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length32","filter":"STRING","condRules":"","priceRules":"","ordering":20},{"id":22,"enabled":true,"fieldset":"1","name":"length-64","label":"length 64","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"64 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"length64","filter":"STRING","condRules":"","priceRules":"","ordering":21},{"id":23,"enabled":true,"fieldset":"1","name":"numeric","label":"Numeric","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Any number","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"numeric","filter":"STRING","condRules":"","priceRules":"","ordering":22},{"id":24,"enabled":true,"fieldset":"1","name":"password","label":"Password","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Valid string for password","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"password","filter":"STRING","condRules":"","priceRules":"","ordering":23},{"id":25,"enabled":true,"fieldset":"1","name":"percent","label":"Percent","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"numeric value for percentage","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"percent","filter":"STRING","condRules":"","priceRules":"","ordering":24},{"id":26,"enabled":true,"fieldset":"1","name":"phone","label":"Phone number","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Phone as NANP pattern","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"phone","filter":"STRING","condRules":"","priceRules":"","ordering":25},{"id":27,"enabled":true,"fieldset":"1","name":"positive-decimal","label":"Positive decimal","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":" Positive decimal","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"positivedecimal","filter":"STRING","condRules":"","priceRules":"","ordering":26},{"id":28,"enabled":true,"fieldset":"1","name":"quote","label":"Quote","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Anything except '' (quote)","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"quote","filter":"STRING","condRules":"","priceRules":"","ordering":27},{"id":29,"enabled":true,"fieldset":"1","name":"date-time","label":"Date time","label_engb":"","description":"","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","latitude":0,"longitude":0,"mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[]","minuteStep":5,"placeholder":"based on field config","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"time","filter":"STRING","condRules":"","priceRules":"","ordering":28},{"id":30,"enabled":true,"fieldset":"1","name":"username","label":"Username","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Valid string for username","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"username","filter":"STRING","condRules":"","priceRules":"","ordering":29},{"id":31,"enabled":true,"fieldset":"1","name":"regex","label":"Regex","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Custom validation (regex) ^\\\\d$","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"regexp","filter":"STRING","regexp":"^\\\\d$","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":"","ordering":30},{"id":32,"enabled":true,"fieldset":"1","name":"captcha","label":"Captcha","label_engb":"","description":"","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Custom validation (regex) ^\\\\d$","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":31}]', '', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions":"0"},"7":{"max_submissions":"0"},"2":{"max_submissions":"0"},"3":{"max_submissions":"0"},"4":{"max_submissions":"0"},"5":{"max_submissions":"0"},"10":{"max_submissions":"0"},"11":{"max_submissions":"0"},"12":{"max_submissions":"0"},"8":{"max_submissions":"0"}}', 5);
INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(6, 'Server side validations', 'fMO8uJp4Df', 'an example of the PHP validations', '[{"id":1,"enabled":true,"ordering":0,"mirror":"","name":"JS validations","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":""}]', '[{"id":3,"enabled":true,"ordering":0,"fieldset":"1","name":"text","label":"Required","label_engb":"","description":"","description_engb":"","type":"cktext","active":false,"afterinput":"","afterinput_engb":"","animated":false,"autoclose":false,"canEdit":null,"canView":null,"class":"","containerClass":"","cols":null,"color":null,"layout_ckcolor":null,"default":"","directory":null,"display":null,"distanceWidget":false,"distanceWidgetRadius":0,"fileFilter":"","exclude":"","start":null,"end":null,"addresspicker_center":"","latitude":0,"longitude":0,"cssSelectorTarget":"","mapType":null,"zoom":null,"mode_ckdatetimepicker":null,"calendars":null,"startDate_type":null,"startDate_fixed":null,"startDate_dynamic":null,"endDate_type":null,"endDate_fixed":null,"endDate_dynamic":null,"firstDay":null,"format":null,"uiFormat":"","minView":null,"maxView":null,"startView":null,"specialDates":"","maxSize":"","allowedExtensions":"","rename":"","indirect":false,"target":null,"actions":null,"preview":false,"width":null,"height":null,"thumbnails":"","hide_none":false,"hide_default":false,"layout":null,"markerType":null,"minuteStep":0,"min":0,"max":0,"mode_ckaddresspicker":null,"multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"Just a required field","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":null,"readonly":false,"disabled":false,"required":true,"newRequired":null,"editRequired":null,"limit":0,"repeatable_fields":"","separator":"","separator_cktags":"","capitalizeFirstLetter":false,"spacer_content":null,"spacer_content_engb":null,"step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":false,"style":"","theme":null,"time":null,"ui":null,"ui_direction":null,"ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":null,"value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","custom_filter":null,"validate":"","regexp":"","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":""},{"id":1,"enabled":true,"ordering":1,"fieldset":"1","name":"color","label":"Color","label_engb":"","description":"","description_engb":"","type":"cktext","active":false,"afterinput":"","afterinput_engb":"","animated":false,"autoclose":false,"canEdit":null,"canView":null,"class":"","containerClass":"","cols":null,"color":null,"layout_ckcolor":null,"default":"","directory":null,"display":null,"distanceWidget":false,"distanceWidgetRadius":0,"fileFilter":"","exclude":"","start":null,"end":null,"addresspicker_center":"","latitude":0,"longitude":0,"cssSelectorTarget":"","mapType":null,"zoom":null,"mode_ckdatetimepicker":null,"calendars":null,"startDate_type":null,"startDate_fixed":null,"startDate_dynamic":null,"endDate_type":null,"endDate_fixed":null,"endDate_dynamic":null,"firstDay":null,"format":null,"uiFormat":"","minView":null,"maxView":null,"startView":null,"specialDates":"","maxSize":"","allowedExtensions":"","rename":"","indirect":false,"target":null,"actions":null,"preview":false,"width":null,"height":null,"thumbnails":"","hide_none":false,"hide_default":false,"layout":null,"markerType":null,"minuteStep":0,"min":0,"max":0,"mode_ckaddresspicker":null,"multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"#ffffff","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":null,"readonly":false,"disabled":false,"required":false,"newRequired":null,"editRequired":null,"limit":0,"repeatable_fields":"","separator":"","separator_cktags":"","capitalizeFirstLetter":false,"spacer_content":null,"spacer_content_engb":null,"step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":false,"style":"","theme":null,"time":null,"ui":null,"ui_direction":null,"ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":null,"value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","custom_filter":null,"validate":"colorcode","regexp":"","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":""},{"id":2,"enabled":true,"ordering":2,"fieldset":"1","name":"credit_card","label":"Credit card","label_engb":"","description":"","description_engb":"","type":"cktext","active":false,"afterinput":"","afterinput_engb":"","animated":false,"autoclose":false,"canEdit":null,"canView":null,"class":"","containerClass":"","cols":null,"color":null,"layout_ckcolor":null,"default":"","directory":null,"display":null,"distanceWidget":false,"distanceWidgetRadius":0,"fileFilter":"","exclude":"","start":null,"end":null,"addresspicker_center":"","latitude":0,"longitude":0,"cssSelectorTarget":"","mapType":null,"zoom":null,"mode_ckdatetimepicker":null,"calendars":null,"startDate_type":null,"startDate_fixed":null,"startDate_dynamic":null,"endDate_type":null,"endDate_fixed":null,"endDate_dynamic":null,"firstDay":null,"format":null,"uiFormat":"","minView":null,"maxView":null,"startView":null,"specialDates":"","maxSize":"","allowedExtensions":"","rename":"","indirect":false,"target":null,"actions":null,"preview":false,"width":null,"height":null,"thumbnails":"","hide_none":false,"hide_default":false,"layout":null,"markerType":null,"minuteStep":0,"min":0,"max":0,"mode_ckaddresspicker":null,"multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"xxxx xxxx xxxx xxxx","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":null,"readonly":false,"disabled":false,"required":false,"newRequired":null,"editRequired":null,"limit":0,"repeatable_fields":"","separator":"","separator_cktags":"","capitalizeFirstLetter":false,"spacer_content":null,"spacer_content_engb":null,"step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":false,"style":"","theme":null,"time":null,"ui":null,"ui_direction":null,"ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":null,"value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","custom_filter":null,"validate":"creditcard","regexp":"","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":""},{"id":7,"enabled":true,"ordering":3,"fieldset":"1","name":"decimal2","label":"Decimal2","label_engb":"","description":"","description_engb":"","type":"cktext","active":false,"afterinput":"","afterinput_engb":"","animated":false,"autoclose":false,"canEdit":null,"canView":null,"class":"","containerClass":"","cols":null,"color":null,"layout_ckcolor":null,"default":"","directory":null,"display":null,"distanceWidget":false,"distanceWidgetRadius":0,"fileFilter":"","exclude":"","start":null,"end":null,"addresspicker_center":"","latitude":0,"longitude":0,"cssSelectorTarget":"","mapType":null,"zoom":null,"mode_ckdatetimepicker":null,"calendars":null,"startDate_type":null,"startDate_fixed":null,"startDate_dynamic":null,"endDate_type":null,"endDate_fixed":null,"endDate_dynamic":null,"firstDay":null,"format":null,"uiFormat":"","minView":null,"maxView":null,"startView":null,"specialDates":"","maxSize":"","allowedExtensions":"","rename":"","indirect":false,"target":null,"actions":null,"preview":false,"width":null,"height":null,"thumbnails":"","hide_none":false,"hide_default":false,"layout":null,"markerType":null,"minuteStep":0,"min":0,"max":0,"mode_ckaddresspicker":null,"multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"XXXXXXXXX.12","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":null,"readonly":false,"disabled":false,"required":false,"newRequired":null,"editRequired":null,"limit":0,"repeatable_fields":"","separator":"","separator_cktags":"","capitalizeFirstLetter":false,"spacer_content":null,"spacer_content_engb":null,"step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":false,"style":"","theme":null,"time":null,"ui":null,"ui_direction":null,"ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":null,"value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","custom_filter":null,"validate":"decimal2","regexp":"","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":""},{"id":6,"enabled":true,"ordering":4,"fieldset":"1","name":"decimal3to1","label":"decimal3to1","label_engb":"","description":"","description_engb":"","type":"cktext","active":false,"afterinput":"","afterinput_engb":"","animated":false,"autoclose":false,"canEdit":null,"canView":null,"class":"","containerClass":"","cols":null,"color":null,"layout_ckcolor":null,"default":"","directory":null,"display":null,"distanceWidget":false,"distanceWidgetRadius":0,"fileFilter":"","exclude":"","start":null,"end":null,"addresspicker_center":"","latitude":0,"longitude":0,"cssSelectorTarget":"","mapType":null,"zoom":null,"mode_ckdatetimepicker":null,"calendars":null,"startDate_type":null,"startDate_fixed":null,"startDate_dynamic":null,"endDate_type":null,"endDate_fixed":null,"endDate_dynamic":null,"firstDay":null,"format":null,"uiFormat":"","minView":null,"maxView":null,"startView":null,"specialDates":"","maxSize":"","allowedExtensions":"","rename":"","indirect":false,"target":null,"actions":null,"preview":false,"width":null,"height":null,"thumbnails":"","hide_none":false,"hide_default":false,"layout":null,"markerType":null,"minuteStep":0,"min":0,"max":0,"mode_ckaddresspicker":null,"multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"12.1","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":null,"readonly":false,"disabled":false,"required":false,"newRequired":null,"editRequired":null,"limit":0,"repeatable_fields":"","separator":"","separator_cktags":"","capitalizeFirstLetter":false,"spacer_content":null,"spacer_content_engb":null,"step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":false,"style":"","theme":null,"time":null,"ui":null,"ui_direction":null,"ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":null,"value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","custom_filter":null,"validate":"decimal3to1","regexp":"","regexpModifiers":"","regexpInvert":false,"condRules":"","priceRules":""},{"id":5,"enabled":true,"fieldset":"1","name":"decimal5to2","label":"Decimal5to2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"123.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"decimal5to2","condRules":"","priceRules":"","ordering":5},{"id":4,"enabled":true,"fieldset":"1","name":"decimal7to2","label":"Decimal7to2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"12345.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"decimal7to2","condRules":"","priceRules":"","ordering":6},{"id":8,"enabled":true,"fieldset":"1","name":"decimal11to8","label":"Decimal11to8","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"123.12345678","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"decimal11to8","condRules":"","priceRules":"","ordering":7},{"id":9,"enabled":true,"fieldset":"1","name":"decimal15to5","label":"Decimal15to5","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"1234567890.12345","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"decimal15to5","condRules":"","priceRules":"","ordering":8},{"id":10,"enabled":true,"fieldset":"1","name":"decimalcomma","label":"Decimalcomma","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"x,x","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"decimalcomma","condRules":"","priceRules":"","ordering":9},{"id":11,"enabled":true,"fieldset":"1","name":"digit","label":"Digit","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"digit","condRules":"","priceRules":"","ordering":10},{"id":12,"enabled":true,"fieldset":"1","name":"domain","label":"Domain","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"http:\\/\\/www.bygiro.com","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"domain","condRules":"","priceRules":"","ordering":11},{"id":13,"enabled":true,"fieldset":"1","name":"doublequote","label":"Doublequote","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Anything except \\" (double quote)","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"doublequote","condRules":"","priceRules":"","ordering":12},{"id":14,"enabled":true,"fieldset":"1","name":"email","label":"Email","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"peter@griffin.com","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"email","condRules":"","priceRules":"","ordering":13},{"id":15,"enabled":true,"fieldset":"1","name":"file","label":"File","label_engb":"","description":"","description_engb":"","type":"ckfile","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","maxSize":"0.5","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"target":"_self","preview":true,"width":"","height":"","thumbnails":"","placeholder":"select a file MAX 500k","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"file","condRules":"","priceRules":"","ordering":14},{"id":16,"enabled":true,"fieldset":"1","name":"ip","label":"IP address","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"127.0.0.1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"ip","condRules":"","priceRules":"","ordering":15},{"id":17,"enabled":true,"fieldset":"1","name":"length-2","label":"length 2","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"2 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length2","condRules":"","priceRules":"","ordering":16},{"id":18,"enabled":true,"fieldset":"1","name":"length-4","label":"length 4","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"4 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length4","condRules":"","priceRules":"","ordering":17},{"id":19,"enabled":true,"fieldset":"1","name":"length-8","label":"length 8","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"8 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length8","condRules":"","priceRules":"","ordering":18},{"id":20,"enabled":true,"fieldset":"1","name":"length-16","label":"length 16","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"16 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length16","condRules":"","priceRules":"","ordering":19},{"id":21,"enabled":true,"fieldset":"1","name":"length-32","label":"length 32","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"32 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length32","condRules":"","priceRules":"","ordering":20},{"id":22,"enabled":true,"fieldset":"1","name":"length-64","label":"length 64","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"64 characthers","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"length64","condRules":"","priceRules":"","ordering":21},{"id":23,"enabled":true,"fieldset":"1","name":"numeric","label":"Numeric","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Any number","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"numeric","condRules":"","priceRules":"","ordering":22},{"id":24,"enabled":true,"fieldset":"1","name":"password","label":"Password","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Valid string for password","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"password","condRules":"","priceRules":"","ordering":23},{"id":25,"enabled":true,"fieldset":"1","name":"percent","label":"Percent","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"numeric value for percentage","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"percent","condRules":"","priceRules":"","ordering":24},{"id":26,"enabled":true,"fieldset":"1","name":"phone","label":"Phone number","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Phone as NANP pattern","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"phone","condRules":"","priceRules":"","ordering":25},{"id":27,"enabled":true,"fieldset":"1","name":"positive-decimal","label":"Positive decimal","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":" Positive decimal","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"positivedecimal","condRules":"","priceRules":"","ordering":26},{"id":28,"enabled":true,"fieldset":"1","name":"quote","label":"Quote","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Anything except '' (quote)","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"quote","condRules":"","priceRules":"","ordering":27},{"id":29,"enabled":true,"fieldset":"1","name":"date-time","label":"Date time","label_engb":"","description":"","description_engb":"","type":"ckdatetimepicker","afterinput":"","afterinput_engb":"","autoclose":true,"class":"","containerClass":"","default":"","mode_ckdatetimepicker":"single","calendars":"1","startDate_type":"","endDate_type":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[]","minuteStep":5,"placeholder":"based on field config","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"separator":" | ","selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"style":"","validate_js":"","filter":"STRING","validate":"time","condRules":"","priceRules":"","ordering":28},{"id":30,"enabled":true,"fieldset":"1","name":"username","label":"Username","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Valid string for username","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"username","condRules":"","priceRules":"","ordering":29},{"id":31,"enabled":true,"fieldset":"1","name":"regex","label":"Regex","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Custom validation (regex) ^\\\\d$","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","validate_js":"","filter":"STRING","validate":"regexp","condRules":"","priceRules":"","ordering":30},{"id":32,"enabled":true,"fieldset":"1","name":"captcha","label":"Captcha","label_engb":"","description":"","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Custom validation (regex) ^\\\\d$","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","validate":"","condRules":"","priceRules":"","ordering":31}]', '', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions":"0"},"7":{"max_submissions":"0"},"2":{"max_submissions":"0"},"3":{"max_submissions":"0"},"4":{"max_submissions":"0"},"5":{"max_submissions":"0"},"10":{"max_submissions":"0"},"11":{"max_submissions":"0"},"12":{"max_submissions":"0"},"8":{"max_submissions":"0"}}', 6),
(7, 'Dynamic price', 'qTJwVMJBbm', '<p>The price will dinamically change based on the user selections</p>', '[{"id":1,"enabled":true,"mirror":"","name":"Basic","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0}]', '[{"id":5,"enabled":true,"fieldset":"1","name":"checkbox","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"12\\"}]","ordering":0},{"id":6,"enabled":true,"fieldset":"1","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","latitude":0,"longitude":0,"layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"a\\",\\"variation\\":\\"-\\",\\"type\\":\\"value\\",\\"price\\":\\"5\\"},{\\"values\\":\\"b\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"13\\"},{\\"values\\":\\"c\\",\\"variation\\":\\"*\\",\\"type\\":\\"percentage\\",\\"price\\":\\"6\\"}]","ordering":1},{"id":10,"enabled":true,"fieldset":"1","name":"textarea","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","startDate_fixed":"","startDate_dynamic":"","endDate_type":"","endDate_fixed":"","endDate_dynamic":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[]","maxSize":"2","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"target":"_self","preview":true,"width":"","height":"","thumbnails":"","hide_none":true,"hide_default":true,"layout":"horizontal","markerType":"default","minuteStep":5,"min":0,"max":0,"mode_ckaddresspicker":"modal","multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":"","readonly":false,"disabled":false,"required":false,"limit":10,"repeatable_fields":[],"separator":" | ","separator_cktags":",","capitalizeFirstLetter":true,"spacer_content":"","spacer_content_engb":"","step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":true,"style":"","theme":"red","time":"0","ui":"default","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":"","value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","validate":"","condRules":"","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"\\/\\",\\"type\\":\\"value\\",\\"price\\":\\"2\\"}]","ordering":2},{"id":14,"enabled":true,"fieldset":"1","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[]","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"+\\",\\"type\\":\\"percentage\\",\\"price\\":\\"30\\"}]","ordering":3},{"id":15,"enabled":true,"fieldset":"1","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"opt1\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"10\\"},{\\"values\\":\\"opt2\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"20\\"},{\\"values\\":\\"opt3\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"30\\"},{\\"values\\":\\"opt4\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"40\\"}]","ordering":4},{"id":22,"enabled":true,"fieldset":"1","name":"radio","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"opt1\\",\\"variation\\":\\"-\\",\\"type\\":\\"value\\",\\"price\\":\\"10\\"},{\\"values\\":\\"opt2|opt3\\",\\"variation\\":\\"*\\",\\"type\\":\\"value\\",\\"price\\":\\"1.5\\"},{\\"values\\":\\"opt4\\",\\"variation\\":\\"\\/\\",\\"type\\":\\"percentage\\",\\"price\\":\\"1.5\\"}]","ordering":5}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":true,"show_price_list":true,"show_price_item":true,"amount_type":"dynamic","price":"50","tax":"22","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions_inherit":true},"7":{"max_submissions_inherit":true},"2":{"max_submissions_inherit":true},"3":{"max_submissions_inherit":true},"4":{"max_submissions_inherit":true},"5":{"max_submissions_inherit":true},"10":{"max_submissions_inherit":true},"11":{"max_submissions":"0"},"12":{"max_submissions_inherit":true},"8":{"max_submissions_inherit":true}}', 7),
(8, 'Fixed price', 'GNUM2L2ayQ', '<p>The price is fixed</p>', '[{"id":1,"enabled":true,"mirror":"","name":"Basic","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0}]', '[{"id":5,"enabled":true,"fieldset":"1","name":"checkbox","label":"Checkbox","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckbox","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","value":"1","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"12\\"}]","ordering":0},{"id":6,"enabled":true,"fieldset":"1","name":"checkboxes","label":"Checkboxes","label_engb":"","description":"You can add a description here","description_engb":"","type":"ckcheckboxes","afterinput":"","afterinput_engb":"","class":"","containerClass":"","cols":"","default":"","latitude":0,"longitude":0,"layout":"horizontal","placeholder":"this is a placeholder","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"Value a\\",\\"label_engb\\":\\"\\",\\"value\\":\\"a\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value b\\",\\"label_engb\\":\\"\\",\\"value\\":\\"b\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"Value c\\",\\"label_engb\\":\\"\\",\\"value\\":\\"c\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"a\\",\\"variation\\":\\"-\\",\\"type\\":\\"value\\",\\"price\\":\\"5\\"},{\\"values\\":\\"b\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"13\\"},{\\"values\\":\\"c\\",\\"variation\\":\\"*\\",\\"type\\":\\"percentage\\",\\"price\\":\\"6\\"}]","ordering":1},{"id":10,"enabled":true,"fieldset":"1","name":"textarea","label":"Textarea","label_engb":"","description":"","description_engb":"","type":"cktextarea","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","startDate_fixed":"","startDate_dynamic":"","endDate_type":"","endDate_fixed":"","endDate_dynamic":"","firstDay":"1","format":"Y-m-d H:i","uiFormat":"","minView":"times","maxView":"years","startView":"days","specialDates":"[]","maxSize":"2","allowedExtensions":"txt,rar,zip,doc,docx,xls,xlsx,jpg,jpeg,png,gif","rename":"{ID}_{RAND}_{BASE}.{EXT}","indirect":true,"target":"_self","preview":true,"width":"","height":"","thumbnails":"","hide_none":true,"hide_default":true,"layout":"horizontal","markerType":"default","minuteStep":5,"min":0,"max":0,"mode_ckaddresspicker":"modal","multiple":false,"nullLabel":"","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","query":"","readonly":false,"disabled":false,"required":false,"limit":10,"repeatable_fields":[],"separator":" | ","separator_cktags":",","capitalizeFirstLetter":true,"spacer_content":"","spacer_content_engb":"","step":0,"selectors":"","showDaysNotInMonth":false,"showDisabledTimes":false,"size":"","stripext":true,"style":"","theme":"red","time":"0","ui":"default","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"value":"","key_field":"","value_field":"","translate":false,"options":"","validate_js":"","filter":"STRING","validate":"","condRules":"","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"\\/\\",\\"type\\":\\"value\\",\\"price\\":\\"2\\"}]","ordering":2},{"id":14,"enabled":true,"fieldset":"1","name":"listsingle","label":"List (single)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":false,"nullLabel":"- select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"default","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"[]","priceRules":"[{\\"values\\":\\"*\\",\\"variation\\":\\"+\\",\\"type\\":\\"percentage\\",\\"price\\":\\"30\\"}]","ordering":3},{"id":15,"enabled":true,"fieldset":"1","name":"listmultiple","label":"List (multiple)","label_engb":"","description":"","description_engb":"","type":"cklist","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","multiple":true,"nullLabel":"- Select a value -","nullLabel_engb":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","size":"","style":"","ui":"multiselect","ui_direction":"horizontal","ui_allowCustomValues":false,"ui_hideSelect":false,"options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"icon\\":\\"\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"opt1\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"10\\"},{\\"values\\":\\"opt2\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"20\\"},{\\"values\\":\\"opt3\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"30\\"},{\\"values\\":\\"opt4\\",\\"variation\\":\\"+\\",\\"type\\":\\"value\\",\\"price\\":\\"40\\"}]","ordering":4},{"id":22,"enabled":true,"fieldset":"1","name":"radio","label":"Radio","label_engb":"","description":"","description_engb":"","type":"ckradio","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"selectors":"","style":"","options":"[{\\"label\\":\\"opt 1\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt1\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"inverse\\",\\"icon\\":\\"icon-basket\\"},{\\"label\\":\\"opt 2\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt2\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"primary\\",\\"icon\\":\\"icon-broadcast\\"},{\\"label\\":\\"opt 3\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt3\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"warning\\",\\"icon\\":\\"icon-dashboard\\"},{\\"label\\":\\"opt 4\\",\\"label_engb\\":\\"\\",\\"value\\":\\"opt4\\",\\"groupBy\\":\\"\\",\\"groupBy_engb\\":\\"\\",\\"class\\":\\"\\",\\"description\\":\\"\\",\\"disabled\\":\\"0\\",\\"color\\":\\"danger\\",\\"icon\\":\\"icon-color-palette\\"}]","validate_js":"","filter":"STRING","condRules":"","priceRules":"[{\\"values\\":\\"opt1\\",\\"variation\\":\\"-\\",\\"type\\":\\"value\\",\\"price\\":\\"10\\"},{\\"values\\":\\"opt2|opt3\\",\\"variation\\":\\"*\\",\\"type\\":\\"value\\",\\"price\\":\\"1.5\\"},{\\"values\\":\\"opt4\\",\\"variation\\":\\"\\/\\",\\"type\\":\\"percentage\\",\\"price\\":\\"1.5\\"}]","ordering":5}]', '<p>Thank you for your submission!</p>', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":true,"show_price_list":true,"show_price_item":true,"amount_type":"fixed","price":"50","tax":"22","payment_instructions":"","payment_instructions_engb":"","payment_instructions_itit":"","thank_you":"","thank_you_engb":"","thank_you_itit":"","failed_payment":"","failed_payment_engb":"","failed_payment_itit":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1,2', '{"1":{"max_submissions":"0"},"9":{"max_submissions":"0"},"6":{"max_submissions_inherit":true},"7":{"max_submissions_inherit":true},"2":{"max_submissions_inherit":true},"3":{"max_submissions_inherit":true},"4":{"max_submissions_inherit":true},"5":{"max_submissions_inherit":true},"10":{"max_submissions_inherit":true},"11":{"max_submissions":"0"},"12":{"max_submissions_inherit":true},"8":{"max_submissions_inherit":true}}', 8);
INSERT INTO `#__jforms_forms` (`id`, `name`, `alias`, `description`, `fieldsets`, `fields`, `message_after_submit`, `language_file`, `emails`, `redirect_after_submit`, `events`, `layouts`, `integrations`, `save_data_in_db`, `generate_pdf`, `layout_type`, `options`, `published`, `access`, `acl`, `ordering`) VALUES
(9, 'ACL fields', 'vMefQPvsyQ', '<p>jForms can manage the joomla standard ACL system. you can set ACL rules for each form, and even on each fields.</p>\r\n<p>Example of ACL feature for fieldsets and single field. try to login with the following users:</p>\r\n<table class="table table-striped table-condensed">\r\n<tbody>\r\n<tr>\r\n<td>1</td>\r\n<td>username: groupa</td>\r\n<td>password: groupa</td>\r\n</tr>\r\n<tr>\r\n<td>2</td>\r\n<td>username: groupb</td>\r\n<td>password: groupb</td>\r\n</tr>\r\n<tr>\r\n<td>3</td>\r\n<td>username: groupc</td>\r\n<td>password: groupc</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n<hr />\r\n<h4 style="font-weight: bold; color: red;">Login with your normal registered account on ByGiro.com to see all the fields</h4>', '[{"id":1,"enabled":true,"mirror":"","name":"ACL fields","name_engb":"","description":"","description_engb":"","class":"form-horizontal","form_file":"","ordering":0}]', '[{"id":3,"enabled":true,"fieldset":"1","name":"text","label":"Required","label_engb":"","description":"","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","placeholder":"Just a required field","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":true,"selectors":"","style":"","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":0},{"id":1,"enabled":true,"fieldset":"1","name":"color","label":"Color","label_engb":"","description":"canView: ALL\\r\\ncanEdit: groupA, groupC\\r\\nrequired (new submission): groupA\\r\\nrequired (edit submission): ALL","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["14","16"],"canView":["1"],"class":"","containerClass":"","default":"","placeholder":"#ffffff","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["14"],"editRequired":["1"],"selectors":"","style":"","validate_js":"colorcode","filter":"STRING","condRules":"","priceRules":"","ordering":1},{"id":2,"enabled":true,"fieldset":"1","name":"credit_card","label":"Credit card","label_engb":"","description":"canView: ALL\\r\\ncanEdit: groupB, groupC\\r\\nrequired (new submission): groupC\\r\\nrequired (edit submission): ALL","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["15","16"],"canView":["1"],"class":"","containerClass":"","default":"","placeholder":"xxxx xxxx xxxx xxxx","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["16"],"editRequired":["1"],"selectors":"","style":"","validate_js":"creditcard","filter":"STRING","condRules":"","priceRules":"","ordering":2},{"id":7,"enabled":true,"fieldset":"1","name":"decimal2","label":"Decimal2","label_engb":"","description":"canView: groupB, groupC\\r\\ncanEdit: groupB\\r\\nrequired (new submission): groupB\\r\\nrequired (edit submission): groupB","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["15"],"canView":["15","16"],"class":"","containerClass":"","default":"","placeholder":"XXXXXXXXX.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["15"],"editRequired":["15"],"selectors":"","style":"","validate_js":"decimal2","filter":"STRING","condRules":"","priceRules":"","ordering":3},{"id":6,"enabled":true,"fieldset":"1","name":"decimal3to1","label":"decimal3to1","label_engb":"","description":"canView:groupA,groupC\\r\\ncanEdit: NONE\\r\\nrequired (new submission): ALL\\r\\nrequired (edit submission): ALL","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canView":["14","16"],"class":"","containerClass":"","default":"","placeholder":"12.1","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["1"],"editRequired":["1"],"selectors":"","style":"","validate_js":"decimal3to1","filter":"STRING","condRules":"","priceRules":"","ordering":4},{"id":5,"enabled":true,"fieldset":"1","name":"decimal5to2","label":"Decimal5to2","label_engb":"","description":"canView: groupA\\r\\ncanEdit: groupA\\r\\nrequired (new submission): groupA\\r\\nrequired (edit submission): groupA","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["14"],"canView":["14"],"class":"","containerClass":"","default":"","placeholder":"123.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["14"],"editRequired":["14"],"selectors":"","style":"","validate_js":"decimal5to2","filter":"STRING","condRules":"","priceRules":"","ordering":5},{"id":4,"enabled":true,"fieldset":"1","name":"decimal7to2","label":"Decimal7to2","label_engb":"","description":"canView: groupB\\r\\ncanEdit: groupB\\r\\nrequired (new submission): groupB\\r\\nrequired (edit submission): groupB","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["15"],"canView":["15"],"class":"","containerClass":"","default":"","placeholder":"12345.12","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["15"],"editRequired":["15"],"selectors":"","style":"","validate_js":"decimal7to2","filter":"STRING","condRules":"","priceRules":"","ordering":6},{"id":8,"enabled":true,"fieldset":"1","name":"decimal11to8","label":"Decimal11to8","label_engb":"","description":"canView: groupC\\r\\ncanEdit: groupC\\r\\nrequired (new submission): groupC\\r\\nrequired (edit submission): groupC","description_engb":"","type":"cktext","afterinput":"","afterinput_engb":"","canEdit":["16"],"canView":["16"],"class":"","containerClass":"","default":"","placeholder":"123.12345678","placeholder_engb":"","printable":true,"readonly":false,"disabled":false,"required":false,"newRequired":["16"],"editRequired":["16"],"selectors":"","style":"","validate_js":"decimal11to8","filter":"STRING","condRules":"","priceRules":"","ordering":7},{"id":32,"enabled":true,"fieldset":"1","name":"captcha","label":"Captcha","label_engb":"","description":"","description_engb":"","type":"ckcaptcha","afterinput":"","afterinput_engb":"","class":"","containerClass":"","default":"","latitude":0,"longitude":0,"placeholder":"Custom validation (regex) ^\\\\d$","placeholder_engb":"","printable":true,"pubkey":"","privkey":"","readonly":false,"disabled":false,"required":false,"selectors":"","style":"","theme":"white","validate_js":"","filter":"STRING","condRules":"","priceRules":"","ordering":8}]', '', '', '[]', '', '[]', '[]', '[]', 1, 1, 'single_form', '{"payment":false,"show_price_list":false,"show_price_item":false,"amount_type":"fixed","price":"","tax":"","payment_instructions":"","payment_instructions_engb":"","thank_you":"","thank_you_engb":"","failed_payment":"","failed_payment_engb":"","client_name":"","client_lastname":"","client_address":"","client_zip":"","client_city":"","client_state":"","client_country":"","client_phone_number":"","client_mobile_number":"","client_email":"","layout_pdf":"","show_title":true,"layout_pre_form":"","layout_form":"","layout_edit_form":"","layout_fly":"","redirect":"custom"}', 1, '1', '{"1":{"max_submissions":"0"},"13":{"max_submissions":"0"},"6":{"max_submissions":"0"},"7":{"max_submissions":"0"},"2":{"max_submissions":"0"},"3":{"max_submissions":"0"},"4":{"max_submissions":"0"},"17":{"max_submissions":"0"},"5":{"max_submissions":"0"},"10":{"max_submissions":"0"},"12":{"max_submissions":"0"},"14":{"max_submissions":"0"},"15":{"max_submissions":"0"},"16":{"max_submissions":"0"},"8":{"max_submissions":"0"}}', 9);
